# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xazureaffinitygroup`](#dsc_xazureaffinitygroup): The DSC xAzureAffinityGroup resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazurequickvm`](#dsc_xazurequickvm): The DSC xAzureQuickVM resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazureservice`](#dsc_xazureservice): The DSC xAzureService resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazuresqldatabase`](#dsc_xazuresqldatabase): The DSC xAzureSqlDatabase resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazuresqldatabaseserverfirewallrule`](#dsc_xazuresqldatabaseserverfirewallrule): The DSC xAzureSqlDatabaseServerFirewallRule resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazurestorageaccount`](#dsc_xazurestorageaccount): The DSC xAzureStorageAccount resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazuresubscription`](#dsc_xazuresubscription): The DSC xAzureSubscription resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazurevm`](#dsc_xazurevm): The DSC xAzureVM resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazurevmdscconfiguration`](#dsc_xazurevmdscconfiguration): The DSC xAzureVMDscConfiguration resource type. Automatically generated from version 0.2.0.0
* [`dsc_xazurevmdscextension`](#dsc_xazurevmdscextension): The DSC xAzureVMDscExtension resource type. Automatically generated from version 0.2.0.0

## Resource types

### `dsc_xazureaffinitygroup`

The DSC xAzureAffinityGroup resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazureaffinitygroup` type.

##### `dsc_description`

Data type: `Optional[String]`

Specifies a description for the affinity group. The description may be up to 1024 characters in length. 

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Azure Affinity Group should be present or absent.

##### `dsc_label`

Data type: `Optional[String]`

Specifies a label for the affinity group. The label may be up to 100 characters in length. 

##### `dsc_location`

Data type: `String`

Specifies the geographical location of the data center where the affinity group will be created.  This must match a value from the Name property of objects returned by Get-AzureLocation.

#### Parameters

The following parameters are available in the `dsc_xazureaffinitygroup` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies a name for the new affinity group that is unique to the subscription.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazurequickvm`

The DSC xAzureQuickVM resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazurequickvm` type.

##### `dsc_adminusername`

Data type: `Optional[String]`

Specifies the name for the administrative account to create.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Azure VM should be present or absent.

##### `dsc_imagename`

Data type: `Optional[String]`

Specifies the name of the operating system image to use to create the operating system disk.

##### `dsc_instancesize`

Data type: `Optional[String]`

Specifies the size of the instance.   For a list of virtual machine sizes, see http://msdn.microsoft.com/library/azure/dn197896.aspx

##### `dsc_linux`

Data type: `Optional[Boolean]`

Creates a Linux virtual machine.

##### `dsc_linuxuser`

Data type: `Optional[String]`

Specifies the Linux administrative account name to create.

##### `dsc_password`

Data type: `Optional[String]`

Specifies the password for the administrative account.

##### `dsc_servicename`

Data type: `String`

Specifies the new or existing service name. 

##### `dsc_windows`

Data type: `Optional[Boolean]`

Creates a Windows virtual machine.

#### Parameters

The following parameters are available in the `dsc_xazurequickvm` type.

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of the virtual machine.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazureservice`

The DSC xAzureService resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazureservice` type.

##### `dsc_affinitygroup`

Data type: `String`

Specifies a description for the service.

##### `dsc_description`

Data type: `Optional[String]`

Specifies the Azure Affinity Group for the service.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the service should be present or absent.

##### `dsc_label`

Data type: `Optional[String]`

Specifies a label for the service.

#### Parameters

The following parameters are available in the `dsc_xazureservice` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_servicename`

namevar

Data type: `String`

Specifies a name for the new cloud service that is unique to the subscription.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazuresqldatabase`

The DSC xAzureSqlDatabase resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazuresqldatabase` type.

##### `dsc_azurepublishsettingsfile`

Data type: `Optional[String]`

Specifies the location of the Publish Settings file for the Azure Subscription

##### `dsc_azuresubscriptionname`

Data type: `Optional[String]`

Specifies the name of the Azure subscription that should be set to Current

##### `dsc_collation`

Data type: `Optional[String]`

Collation of the database

##### `dsc_edition`

Data type: `Optional[String]`

Edition of the database

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure that database is present or absent

##### `dsc_maximumsizeingb`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum size of the database in GB

##### `dsc_servername`

Data type: `String`

Name of the database server

#### Parameters

The following parameters are available in the `dsc_xazuresqldatabase` type.

##### `dsc_name`

namevar

Data type: `String`

Name of the database

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_servercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential to the database server

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazuresqldatabaseserverfirewallrule`

The DSC xAzureSqlDatabaseServerFirewallRule resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazuresqldatabaseserverfirewallrule` type.

##### `dsc_azurepublishsettingsfile`

Data type: `Optional[String]`

Specifies the location of the Publish Settings file for the Azure Subscription

##### `dsc_azuresubscriptionname`

Data type: `Optional[String]`

Specifies the name of the Azure subscription that should be set to Current

##### `dsc_endipaddress`

Data type: `String`

End IP address of the firewall rule

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure that firewall rule is present or absent

##### `dsc_startipaddress`

Data type: `String`

Start IP address of the firewall rule

#### Parameters

The following parameters are available in the `dsc_xazuresqldatabaseserverfirewallrule` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_rulename`

namevar

Data type: `String`

Name of the firewall rule

##### `dsc_servername`

namevar

Data type: `String`

Name of the database server for which firewall rule should be created

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazurestorageaccount`

The DSC xAzureStorageAccount resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazurestorageaccount` type.

##### `dsc_affinitygroup`

Data type: `String`

Specifies the name of an existing affinity group in the current subscription. You can specify either a Location or an AffinityGroup parameter, but not both. 

##### `dsc_container`

Data type: `Optional[String]`

Specifies a name for the Container that should be created in the Azure Storage Account.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Azure Storage Account should be present or absent.

##### `dsc_folder`

Data type: `Optional[String]`

Specifies a local folder.  All files in the root of the folder will be uploaded to the new container.

##### `dsc_label`

Data type: `Optional[String]`

Specifies a label for the storage account. The label may be up to 100 characters in length.

#### Parameters

The following parameters are available in the `dsc_xazurestorageaccount` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_storageaccountname`

namevar

Data type: `String`

Specifies a name for the storage account. The storage account name must be unique to Windows Azure and must be between 3
and 24 characters in length and use lowercase letters and numbers only.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazuresubscription`

The DSC xAzureSubscription resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazuresubscription` type.

##### `dsc_azurepublishsettingsfile`

Data type: `Optional[String]`

Specifies the location of the Publish Settings file for the Azure Subscription.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the subscription should be present or absent.

#### Parameters

The following parameters are available in the `dsc_xazuresubscription` type.

##### `dsc_azuresubscriptionname`

namevar

Data type: `String`

Specifies the name of the Azure subscription that should be set to Current.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazurevm`

The DSC xAzureVM resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazurevm` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the Azure VM should be present or absent.

##### `dsc_extensioncontainername`

Data type: `Optional[String]`

The name of the Container in Azure Blob storage where the script files will reside.  Case sensitive.

##### `dsc_extensionfilelist`

Data type: `Optional[String]`

List of files in Azure Blob container that should be copied in to the VM.  Case sensitive.

##### `dsc_extensionscriptname`

Data type: `Optional[String]`

Name of one of the files in the container that will be exectued at startup.  Case sensitive.

##### `dsc_imagename`

Data type: `String`

Specifies the name of the operating system image to use to create the operating system disk.

##### `dsc_instancesize`

Data type: `Optional[String]`

Specifies the size of the instance.   For a list of virtual machine sizes, see http://msdn.microsoft.com/library/azure/dn197896.aspx

##### `dsc_linux`

Data type: `Optional[Boolean]`

Creates a Linux virtual machine.

##### `dsc_servicename`

Data type: `String`

Specifies the new or existing service name.

##### `dsc_storageaccountname`

Data type: `String`

Specifies the name of the storage account for the VM.

##### `dsc_windows`

Data type: `Optional[Boolean]`

Creates a Windows virtual machine.

#### Parameters

The following parameters are available in the `dsc_xazurevm` type.

##### `dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_name`

namevar

Data type: `String`

Specifies the name of the virtual machine.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazurevmdscconfiguration`

The DSC xAzureVMDscConfiguration resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazurevmdscconfiguration` type.

##### `dsc_azurepublishsettingspath`

Data type: `Optional[String]`

Specifies the location of the Publish Settings file for the Azure Subscription.

##### `dsc_azuresubscriptionname`

Data type: `Optional[String]`

Specifies the name of the Azure subscription that should be set to Current.

##### `dsc_bloburi`

Data type: `Optional[String]`

Absolute Uri of the Blob

##### `dsc_configurationpath`

Data type: `String`

Specifies location of the Dsc Configuration document

##### `dsc_containername`

Data type: `Optional[String]`

Specifies the name of the Container in the Azure Storage Account.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Specifies whether the supplied Configuration is Present or Absent in Azure Storage

#### Parameters

The following parameters are available in the `dsc_xazurevmdscconfiguration` type.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_storageaccountname`

namevar

Data type: `String`

Specifies name of the existing storage account.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xazurevmdscextension`

The DSC xAzureVMDscExtension resource type.
Automatically generated from version 0.2.0.0

#### Properties

The following properties are available in the `dsc_xazurevmdscextension` type.

##### `dsc_code`

Data type: `Optional[String]`

Returns the message code for the latest oepration by the DSC Extension.

##### `dsc_configuration`

Data type: `Optional[String]`

Name of the configuration script or module that will be invoked by the DSC Extension.

##### `dsc_configurationarchive`

Data type: `String`

The name of the configuration package .zip file that was previously uploaded by Publish-AzureVMDscConfiguration. This parameter must specify only the name of the file, without any path.

##### `dsc_configurationargument`

Data type: `Optional[Struct[{
              key => Optional[String],
              value => Optional[String],
            }]]`

A hashtable specifying the arguments to the configuration function. The keys correspond to the parameter names and the values to the parameter values.

##### `dsc_configurationdatapath`

Data type: `Optional[String]`

The path to a .psd1 file that specifies the data for the configuration function.

##### `dsc_containername`

Data type: `Optional[String]`

Name of the Azure Storage Container where the ConfigurationArchive is located.

##### `dsc_message`

Data type: `Optional[String]`

Returns the formatted message string for the latest operation by the DSC Extension.

##### `dsc_referencename`

Data type: `Optional[String]`

The Extension Reference Name

##### `dsc_servicename`

Data type: `String`

Specifies name of the Service where the VM is deployed.

##### `dsc_status`

Data type: `Optional[String]`

Returns the state of the DSC Extension from Azure.

##### `dsc_storageaccountname`

Data type: `String`

Specifies the name of the Storage Account used to create the Storage Context.  The Azure Storage Context provides the security settings used to access the configuration script. This context should provide read access to the container specified by ContainerName.

##### `dsc_storageendpointsuffix`

Data type: `Optional[String]`

The DNS endpoint suffix for all storage services, e.g. core.windows.net

##### `dsc_timestamp`

Data type: `Optional[String]`

Returns the timestamp of the last DSC Extension execution.

##### `dsc_version`

Data type: `Optional[String]`

The specific version of the DSC Extension to use. If not given, it will default to 1.*

#### Parameters

The following parameters are available in the `dsc_xazurevmdscextension` type.

##### `dsc_force`

Data type: `Optional[Boolean]`

By default Set-AzureVMDscExtension will not overwrite any existing blobs. Use -Force to overwrite them.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_vmname`

namevar

Data type: `String`

Specifies name of the VM.  This is used together with ServiceName to construct a persistent vm object.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

