require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xazuresqldatabaseserverfirewallrule',
  dscmeta_resource_friendly_name: 'xAzureSqlDatabaseServerFirewallRule',
  dscmeta_resource_name: 'MSFT_xAzureSqlDatabaseServerFirewallRule',
  dscmeta_module_name: 'xAzure',
  dscmeta_module_version: '0.2.0.0',
  docs: 'The DSC xAzureSqlDatabaseServerFirewallRule resource type.
         Automatically generated from version 0.2.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_startipaddress: {
      type: 'String',
      desc: 'Start IP address of the firewall rule',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_servername: {
      type: 'String',
      desc: 'Name of the database server for which firewall rule should be created',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Ensure that firewall rule is present or absent',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_azurepublishsettingsfile: {
      type: 'Optional[String]',
      desc: 'Specifies the location of the Publish Settings file for the Azure Subscription',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_azuresubscriptionname: {
      type: 'Optional[String]',
      desc: 'Specifies the name of the Azure subscription that should be set to Current',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_rulename: {
      type: 'String',
      desc: 'Name of the firewall rule',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_endipaddress: {
      type: 'String',
      desc: 'End IP address of the firewall rule',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
