require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xazurevmdscconfiguration',
  dscmeta_resource_friendly_name: 'xAzureVMDscConfiguration',
  dscmeta_resource_name: 'MSFT_xAzureVMDscConfiguration',
  dscmeta_module_name: 'xAzure',
  dscmeta_module_version: '0.2.0.0',
  docs: 'The DSC xAzureVMDscConfiguration resource type.
         Automatically generated from version 0.2.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_bloburi: {
      type: 'Optional[String]',
      desc: 'Absolute Uri of the Blob',
      behaviour: :read_only,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_azurepublishsettingspath: {
      type: 'Optional[String]',
      desc: 'Specifies the location of the Publish Settings file for the Azure Subscription.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_storageaccountname: {
      type: 'String',
      desc: 'Specifies name of the existing storage account.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_ensure: {
      type: "Optional[Enum['Present', 'Absent']]",
      desc: 'Specifies whether the supplied Configuration is Present or Absent in Azure Storage',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_containername: {
      type: 'Optional[String]',
      desc: 'Specifies the name of the Container in the Azure Storage Account.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_azuresubscriptionname: {
      type: 'Optional[String]',
      desc: 'Specifies the name of the Azure subscription that should be set to Current.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_configurationpath: {
      type: 'String',
      desc: 'Specifies location of the Dsc Configuration document',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
